package cdkl.LifeGame;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;

public class LifeRuleUI extends Form implements CommandListener {

	private ChoiceGroup[] cg;
	private LifeRule lifeRule;
	private UICanvas main;
	private Display dd;

	public LifeRuleUI (UICanvas f, Display d) {
		super("LifeRule");
		main = f;
		dd = d;
		setCommandListener(this);
		addCommand(new Command("OK", Command.BACK, 1));
		Image[] imageArray = new Image[16];
		String prefix = "/LifeGame/";
		try {
			// load the duke image to place in the image array
			imageArray[0] = Image.createImage(prefix+"cellEnv.png");
			imageArray[1] = Image.createImage(prefix+"cellEnv_N.png");
			imageArray[2] = Image.createImage(prefix+"cellEnv_W.png");
			imageArray[3] = Image.createImage(prefix+"cellEnv_NW.png");
			imageArray[4] = Image.createImage(prefix+"cellEnv_S.png");
			imageArray[5] = Image.createImage(prefix+"cellEnv_NS.png");
			imageArray[6] = Image.createImage(prefix+"cellEnv_WS.png");
			imageArray[7] = Image.createImage(prefix+"cellEnv_XE.png");
			imageArray[8] = Image.createImage(prefix+"cellEnv_E.png");
			imageArray[9] = Image.createImage(prefix+"cellEnv_EN.png");
			imageArray[10] = Image.createImage(prefix+"cellEnv_EW.png");
			imageArray[11] = Image.createImage(prefix+"cellEnv_XS.png");
			imageArray[12] = Image.createImage(prefix+"cellEnv_ES.png");
			imageArray[13] = Image.createImage(prefix+"cellEnv_XW.png");
			imageArray[14] = Image.createImage(prefix+"cellEnv_XN.png");
			imageArray[15] = Image.createImage(prefix+"cellEnv_X.png");
		} catch(java.io.IOException err) {
			// ignor the image loading failure the application can recover.
			System.out.println(err);
		}

		cg = new ChoiceGroup[16];
		for (int i = 0; i < cg.length; i++) {
			cg[i] = new ChoiceGroup("", ChoiceGroup.MULTIPLE, new String[] {"ALIVE"}, null);
		}
		//w]rule
		boolean[] truebool = new boolean[1];
		//boolean[] falsebool = new boolean[1];
		truebool[0] = true;
		//falsebool[0] = false;
		cg[1].setSelectedFlags(truebool);
		cg[2].setSelectedFlags(truebool);
		cg[4].setSelectedFlags(truebool);
		cg[8].setSelectedFlags(truebool);
		for (int i = 0; i < imageArray.length; i++) {
			append(imageArray[i]);
			append("\n");
			append(cg[i]);
			
			try {
				append(Image.createImage(prefix+"line.png"));
			} catch (java.io.IOException err) {
				System.out.println(err);
			}

		}

		lifeRule = new LifeRule();
	}
	
	public void commandAction(Command c, Displayable d) {
		//setRule
		boolean[] ruleResult = new boolean[16];
		for (int i = 0; i < 16; i++) {
			if (cg[i].isSelected(0))
				ruleResult[i] = true;
		}
/*
		int bitstring = 0;
		if (cg[0].isSelected(0))
			bitstring += 1;
		if (cg[1].isSelected(0))
			bitstring += 2;
		if (cg[2].isSelected(0))
			bitstring += 4;
		if (cg[3].isSelected(0))
			bitstring += 8;
		if (cg[4].isSelected(0))
			bitstring += 16;
		if (cg[5].isSelected(0))
			bitstring += 32;
		if (cg[6].isSelected(0))
			bitstring += 64;
		if (cg[7].isSelected(0))
			bitstring += 128;
		if (cg[8].isSelected(0))
			bitstring += 256;
		if (cg[9].isSelected(0))
			bitstring += 512;
		if (cg[10].isSelected(0))
			bitstring += 1024;
		if (cg[11].isSelected(0))
			bitstring += 2048;
		if (cg[12].isSelected(0))
			bitstring += 4096;
		if (cg[13].isSelected(0))
			bitstring += 8192;
		if (cg[14].isSelected(0))
			bitstring += 16384;
		if (cg[15].isSelected(0))
			bitstring += 32768;
		lifeRule.setRule(bitstring);
*/
		lifeRule.setRule(ruleResult);
		dd.setCurrent(main);
	}
	
	public LifeRule getLifeRule() {
		return lifeRule;
	}
}
