package cdkl.LifeGame;
import cdkl.About;

//import java.io.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.rms.*;




public class lifeUI extends MIDlet implements CommandListener, ItemStateListener{

	private Display   myDisplay;
	private Form      menuForm;
	private Form	  saveForm;
	private UICanvas  myCanvas;

	public boolean firsttime = true;
	private int edgeLength = 0;
	static int cellEL = 4;
	public int x;
	public int y;
	public int w;
	public int h;

	static final int INIT_STATUS = 0;			//init / reset
	static final int RUN_STATUS = 1;			//when opened or pressed then go
	static final int OPENED_STATUS = 2;			//when opened a db
	static final int PRESSED_STATUS = 3;			//when pressed on the screen


	public RmsDB db=new RmsDB();
	public LifePool LP;
	private LifeRuleUI LRUI;
	List readlist;
	private TextField savename;


	private Command stepCMD
			= new Command("step", Command.ITEM, 4);
	private Command resetCMD
			= new Command("reset", Command.ITEM, 5);
	private Command setruleCMD
			= new Command("setrule", Command.ITEM, 6);
	private Command menuCMD 
			= new Command("menu", Command.ITEM, 7);
	private Command aboutCMD 
			= new Command("about", Command.ITEM, 8);
	private Command exitCMD 
			= new Command("exit", Command.ITEM, 9);

	private Command openCMD 
			= new Command("OPEN", Command.ITEM, 1);
	private Command saveCMD 
			= new Command("SAVE", Command.ITEM, 2);
			
	private Command savenewCMD 
			= new Command("SAVEnew", Command.ITEM, 2);

	private Command delCMD 
			= new Command("DEL", Command.ITEM, 3);
	private Command backCMD 
			= new Command("BACK", Command.OK, 4);
	




	public lifeUI()
	{
		super();

		myDisplay = Display.getDisplay(this);
		//oӬODnL
		myCanvas  = new UICanvas(this);
		myCanvas.setCommandListener(this);
		myCanvas.addCommand(setruleCMD);
		myCanvas.addCommand(menuCMD);
		myCanvas.addCommand(aboutCMD);
		myCanvas.addCommand(exitCMD);

		LRUI = new LifeRuleUI(myCanvas, myDisplay);
	}

	public void init() throws MIDletStateChangeException
	{
	}

	public void startApp() throws MIDletStateChangeException
	{
		myDisplay.setCurrent(myCanvas);
	}

	public void pauseApp()
	{
		// System.out.println("pauseApp()");
	}

	public void destroyApp(boolean cond)
	{
		myDisplay.setCurrent(null);
		myCanvas.destroy();
	}


	public int getUIwidth()
	{
		if (!firsttime)
			return w;
		return -1;
	}

	public int getUIheight()
	{
		if (!firsttime)
			return h;
		return -1;
	}

	public int getPoolLength()
	{
		if (!firsttime)
			return edgeLength;
		return -1;
	}




	//=====================================================================================

	public void paint(Graphics g) {
		String title=toString();
		switch (myCanvas.getStatus()) {

			case INIT_STATUS://init or reset

				w = g.getClipWidth();
				h = g.getClipHeight();
				edgeLength = ((w>h)?h:w) / cellEL;
				int span = (w-edgeLength*cellEL)/2;
				x = span+g.getClipX();
				y = g.getClipY();
				if (firsttime)
				{
					LP = new LifePool(edgeLength);
					firsttime = false;
				}
				paint_glic(g);
				break;

			case OPENED_STATUS:
				paint_pool(g);
				break;
				
	    		case PRESSED_STATUS:
				paint_pool(g);
				myCanvas.addCommand(stepCMD);
				myCanvas.addCommand(resetCMD);
				break;

			case RUN_STATUS:
				paint_diffPool(g);
				break;

			default:
				break;
		}
		//g.setColor(0x000000);
		//g.drawString(title, 0, 0, Graphics.TOP|Graphics.LEFT);
	}
	//END OF PAINT ()


	//get a New Screen

	private Screen genSaveMenu(){
		if (saveForm == null)
		{
			saveForm = new Form("SAVE");
			saveForm.addCommand(saveCMD);
			saveForm.addCommand(backCMD);
			saveForm.setCommandListener(this);
			saveForm.setItemStateListener(this);
		
			savename = new TextField("Name:","",10,TextField.ANY);
			saveForm.append(savename);
		}
		return saveForm;
		
	}



	/*private Screen genMenu() {
		if (menuForm == null) {
			menuForm = new Form("MENU");
			menuForm.addCommand(openCMD);
			menuForm.addCommand(backCMD);
			menuForm.addCommand(saveCMD);
			menuForm.addCommand(delCMD);
			menuForm.setCommandListener(this);
			menuForm.setItemStateListener(this);
			db.open();
 			readlist= new List("title",List.IMPLICIT,db.printPatternName(),null);
			db.close();
			menuForm.append(readlist);
		}
		return menuForm;
	}
	*/

	private void paint_glic(Graphics gg)
	{
		gg.setColor(0xFFFFFF);
		gg.fillRect(0,0,w,h);
		gg.setColor(0xC7C790);
		for (int i=0;i<=edgeLength;i++)
		{
			gg.drawLine(x+i*cellEL,y,x+i*cellEL,y+edgeLength*cellEL);//eu
			gg.drawLine(x,y+i*cellEL,x+edgeLength*cellEL,y+i*cellEL);//eu
		}
	}		

	private void paint_pool(Graphics gg)
	{
		
		gg.setColor(0xFFFFFF);
		gg.fillRect(0,0,w,h);
		gg.setColor(0xC7C790);
		for (int i=0;i<=edgeLength;i++)
		{
			gg.drawLine(x+i*cellEL,y,x+i*cellEL,y+edgeLength*cellEL);//eu
			gg.drawLine(x,y+i*cellEL,x+edgeLength*cellEL,y+i*cellEL);//eu
		}
		gg.setColor(0x2A9000);//
		for (int i=0;i<edgeLength;i++)
		{
			for (int j=0;j<edgeLength;j++)
			{		
				if (LP.getCell(i,j))
					gg.fillRect(x+j*cellEL+1,y+i*cellEL+1,cellEL-1,cellEL-1);
			}
		}
	}		

       private void paint_diffPool(Graphics gg)
	{
		boolean[][] Pool=LP.getDiffPool();
		boolean[] currentPool=LP.getPool();
		int p=0;
		
		gg.setColor(0xFFFFFF);
		gg.fillRect(0,0,w,h);
		gg.setColor(0xC7C790);
		for (int i=0;i<=edgeLength;i++)
		{
			gg.drawLine(x+i*cellEL,y,x+i*cellEL,y+edgeLength*cellEL);//eu
			gg.drawLine(x,y+i*cellEL,x+edgeLength*cellEL,y+i*cellEL);//eu
		}
		
		
		for (int i=0;i<edgeLength;i++)
		{
			for (int j=0;j<edgeLength;j++)
			{		
				if(Pool[i][j])
				{
				   if (currentPool[p])
				      {
				           gg.setColor(0x2A9000);//
					   gg.fillRect(x+j*cellEL+1,y+i*cellEL+1,cellEL-1,cellEL-1);
				      }
				   else
				      {
				      	   gg.setColor(0xFFFFFF);//white
				           gg.fillRect(x+j*cellEL+1,y+i*cellEL+1,cellEL-1,cellEL-1);
				      }
				}
				p++;
			}//end of for
		}//end of for
	}

	//sO åBܤPs
	public void commandAction(Command cmd, Displayable disp)
	{


			if (cmd == stepCMD)
			{
					LP.setLifeRule(LRUI.getLifeRule());
					LP.nextStage();
					myCanvas.setStatus(RUN_STATUS);
			}

			else if (cmd == resetCMD)
			{
					LP.purify();
					myCanvas.removeCommand(stepCMD);
					myCanvas.setStatus(INIT_STATUS);
			}

			else if (cmd == aboutCMD)
			{
					About.showAbout(myDisplay);
			}

			else if (cmd == exitCMD)
			{
					destroyApp(false);
					notifyDestroyed();
			}

			else if (cmd == menuCMD)
			{
				db.open();
 				readlist= new List("title",List.IMPLICIT,db.printPatternName(),null);
				db.close();				
				readlist.addCommand(openCMD);
				readlist.addCommand(backCMD);
				readlist.addCommand(saveCMD);
				readlist.addCommand(savenewCMD);
				readlist.addCommand(delCMD);
				readlist.setCommandListener(this);
				//readlist.setItemStateListener(this);
				//myDisplay.setCurrent(genMenu());
				myDisplay.setCurrent(readlist);
			}

			else if (cmd == backCMD & disp == readlist)//menuForm)
			{
					myDisplay.setCurrent(myCanvas);
					
			}

			else if (cmd == openCMD & disp == readlist)//menuForm)
			{
					int index=readlist.getSelectedIndex();
					if (index==-1)
						myDisplay.setCurrent(myCanvas);
					
					else
					{	
						db.open();
						LP.setPool(db.find(readlist.getString(index)));
						db.close();
						myCanvas.setStatus(RUN_STATUS);
						myCanvas.addCommand(stepCMD);	
						myDisplay.setCurrent(myCanvas);
						myCanvas.repaint();
						
					}					
					
			}

			else if (cmd == backCMD & disp == saveForm)
			{
				db.open();
 				readlist= new List("title",List.IMPLICIT,db.printPatternName(),null);
				db.close();				
				readlist.addCommand(openCMD);
				readlist.addCommand(backCMD);
				readlist.addCommand(saveCMD);
				readlist.addCommand(delCMD);
				readlist.setCommandListener(this);
				//readlist.setItemStateListener(this);
				//myDisplay.setCurrent(genMenu());
				myDisplay.setCurrent(readlist);
				
					//myDisplay.setCurrent(genMenu());
			}
			
			else if (cmd == saveCMD & disp == saveForm)
			{
					db.open();
					db.addPattern(savename.getString(),LP.getPool());
					db.close();
					myCanvas.setStatus(RUN_STATUS);
					myCanvas.addCommand(stepCMD);	
					myDisplay.setCurrent(myCanvas);
			}
                        
			else if (cmd == saveCMD & disp == readlist)//menuForm)
			{
					int index=readlist.getSelectedIndex();
					
					if (index==-1)
						myDisplay.setCurrent(genSaveMenu());
					
					else
					{
						db.open();
						db.addPattern(readlist.getString(index),LP.getPool());
						db.close();
						myCanvas.setStatus(RUN_STATUS);
						myCanvas.addCommand(stepCMD);	
						myDisplay.setCurrent(myCanvas);
					}
			}
                        else if (cmd == savenewCMD & disp == readlist)//menuForm)
			{
                                        myDisplay.setCurrent(genSaveMenu());
			}
			
			else if (cmd == delCMD & disp == readlist)//menuForm)
			{
					int index=readlist.getSelectedIndex();
					if (index==-1)
						myDisplay.setCurrent(myCanvas);
					
					else
					{
						db.open();
						db.deletePattern(readlist.getString(index));
						db.close();
						myDisplay.setCurrent(myCanvas);
					}
			}

			else if (cmd == setruleCMD)
			{
					myDisplay.setCurrent(LRUI);
			}
			myCanvas.repaint();
	}

	public String toString() {
			String tmp = "Status: "+myCanvas.getStatus();
			return tmp;
	} 

	public void itemStateChanged(Item item) {
			//	if (item == borderChoice) {
			//menuForm.setStyle(borderChoice.getSelectedIndex());
			//	} else if (item == speedChoice) {
			//menuForm.setSpeed(speedChoice.getSelectedIndex());
			//	}
	}
}
